{-# OPTIONS_GHC -XNPlusKPatterns #-}

{----------------------------}
{----------s1132388----------}
{-Tarlungianu Claudiu Andrei-}
{----------------------------}

{----------------------------------------------}
               {-!!!Competition!!!-}
{----------------------------------------------}

import LSystem

{------------------------------------------------------------------------------
	The program is able to represent the four seasons in the year.
	Just type in the name of the season: winter
					     spring
					     summer
					     autumn
	
	Please be patient as it takes time for it to draw all the stuff.

Credit goes to Stuart Taylor from 2007 Haskell Competition
for my "fractal" function, which is modeled after his.
-------------------------------------------------------------------------------}

{------------------------}
{-Similar to S. Taylor's-}
{------------------------}

fractal c x = f x
          where
          f 0 = GrabPen c :#: Go 20 :#: circle 0.2
          f ( x + 1 ) = g x :#: Branch ( GrabPen c :#: Turn 45 :#: f x )
                            :#: Branch ( GrabPen c :#: Turn ( -45 ) :#: f x )
                            :#: Branch ( GrabPen black :#: g x :#: f x )
          g 0 = Go 35
          g ( x + 1 ) = g x :#: GrabPen black :#: Branch ( Turn 30 :#: g x )
                            :#: GrabPen black :#: Branch ( Turn ( -30 ) :#: g x )

{-------------------}
{-Helping functions-}
{-------------------}

join [] = Sit
join (x:xs) = x :#: join xs

circle :: Distance -> Command
circle n = Turn (-90) :#: copy 36 (Go (n * 3) :#: Turn 10) :#: Turn 90
partCircle n = Turn (-90) :#: copy 12 (Go (n * 3) :#: Turn 10) :#: Turn 90
partCircle2 n = Turn (-90) :#: copy 6 (Go (n * 3) :#: Turn 10) :#: Turn 90

patch c1 c2 n = GrabPen c1 :#: segment32 2 n 80 :#: Turn 170 :#: Go (-50) :#: segment32 2 n 80 :#: Go 20 :#: GrabPen c2 :#: segment32 2 n 70

petala n = partCircle2 n :#: Turn 10 :#: partCircle n :#: Turn 10 :#: partCircle2 n

cloud n = GrabPen cloudy :#: partCircle n :#: Turn (-100) :#: partCircle (n + 0.5) :#: Turn (-100) :#: partCircle n :#: Turn (-100) :#: partCircle (n + 0.45) :#: Turn (-70) :#: partCircle n :#: Turn (-60) :#: partCircle (n - 0.2) :#: Turn (-100) :#: partCircle (n + 0.35) :#: Turn (-80) :#: partCircle (n + 0.2) :#: Turn (-110) :#: partCircle n :#: Turn (-96.5) :#: partCircle (n + 0.485) :#: Turn (-50) :#: partCircle (n - 2.8)

copy n c = join [ x | (x,i) <- zip (repeat c) [1..n] ]

snowflake x y = f x :#: p :#: p :#: f x :#: p :#: p :#: f x :#: p :#: p
	  where
	  f 0 = Go y
	  f (x+1) = f x :#: n :#: f x :#: p :#: p :#: f x :#: n :#: f x
	  n = Turn 60
	  p = Turn (-60)

peano x = f x
	    where
	    f 0 = Go 1
	    f (x+1) = f x :#: n :#: g x :#: n :#: n :#: g x:#: p:#: f x:#: p :#: p :#: f x :#: f x :#: p :#: g x :#: n
	    g 0 = Go 1
	    g (x+1) = p :#: f x:#: n :#: g x :#: g x :#: n :#: n :#: g x :#: n :#: f x :#: p :#: p :#: f x :#: p :#: g x
	    n = Turn 60
	    p = Turn (-60)

cross x y = f x :#: p :#: f x :#: p :#: f x :#: p :#: f x :#: p
      where
      f 0 = Go y
      f (x+1) = f x :#: p :#: f x :#: n :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: p :#: f x :#: n :#: f x
      n = Turn 90
      p = Turn (-90)

segment32 x y z = f x :#: n :#: f x :#: n :#: f x :#: n :#: f x
	  where
	  f 0 = Go y
	  f (x+1) = p :#: f x :#: n :#: f x :#: p :#: f x :#: p :#: f x :#: n :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: n :#: f x :#: n :#: f x :#: f x :#: n :#: f x :#: p :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: n :#: f x :#: p :#: f x :#: f x :#: p :#: f x :#: p :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: n :#: f x :#: p :#: f x :#: n 
	  n = Turn z
	  p = Turn (-z)

branch x = g x
       where
       g 0 = GrabPen black :#: Go 5
       g (x+1) = f x :#: p :#: Branch ( Branch (g x) :#: n :#: g x) :#: n :#: f x :#: Branch (n :#: f x :#: g x) :#: p :#: g x
       f 0 = Go 5
       f (x+1) = f x :#: f x
       n = Turn 22.5
       p = Turn (-22.5)

sf x = f x :#: p :#: f x :#: p :#: f x :#: p :#: f x
    where
    f 0 = GrabPen black :#: Go 10
    f (x+1) = n :#: f x :#: p :#: f x :#: n :#: f x :#: n :#: f x :#: p :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: p :#: f x :#: p :#: f x :#: f x :#: p :#: f x :#: n :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: f x :#: p :#: f x :#: p :#: f x :#: n :#: f x :#: f x :#: n :#: f x :#: n :#: f x :#: p :#: f x :#: f x :#: n :#: f x :#: n :#: f x :#: p :#: f x :#: p :#: f x :#: n :#: f x :#: p 
    n = Turn 90
    p = Turn (-90)

branch' x = g x
       	where
       	f 0 = Go 5
       	f (x+1) = f x :#: p :#: Branch ( Branch (g x) :#: n :#: g x) :#: n :#: f x :#: Branch (n :#: f x :#: g x) :#: p :#: g x
       	g 0 = Go 5
       	g (x+1) = f x :#: f x
       	n = Turn 22.5
       	p = Turn (-22.5)

branch'' x = g x
       	where
       	f 0 = Go 10
       	f (x+1) = f x :#: p :#: Branch ( Branch (g x) :#: n :#: g x) :#: n :#: f x :#: Branch (n :#: f x :#: g x) :#: p :#: g x
       	g 0 = Go 5
       	g (x+1) = f x :#: f x
       	n = Turn 22.5
       	p = Turn (-22.5)

bush x = f x
  where 
  f 0     = GrabPen blue :#: Go 10
  f (x+1) = g x :#: n :#: Branch (Branch (f x) :#: p :#: f x)
                :#: p :#: g x
                :#: Branch (p :#: g x :#: f x) 
                :#: n :#: f x
  g 0     = GrabPen red :#: Go 10
  g (x+1) = g x :#: g x
  n = Turn 22.5
  p = Turn (-22.5)

join2 [x] = x
join2 (x:xs) = x :#: join2 xs

repeater c n = join2 [ c | i <- [1..n] ]

{---------}
{-Colours-}
{---------}

brown = Colour 0.4 0.1 0.2
darkBlue = Colour 0 0 0.54
yellow = Colour 1 0.89 0.01
midnightBlue = Colour 0.01 0.01 0.5
treeAutumn = Colour 0.9 0.1 0.1
treeAutumn2 = Colour 0.6 0.2 0
treeWinter = Colour 0.67 0.67 0.67
treeWinter2 = Colour 0.5 0.5 0.5
treeWinter3 = Colour 0.8 0.8 0.8
treeSummer = Colour 0.4 0.62 0.2
treeSummer2 = Colour 0.43 0.65 0.23
treeSpring = Colour 0.4 0.62 0.2
treeSpring2 = Colour 0.22 0.37 0.06
sunnyS = Colour 1 0.89 0.01
sunnyW = Colour 1 0.6 0.07
sunnyA = Colour 1 0.6 0.07
rainColour = Colour 0.49 0.62 0.75
crossColour = Colour 0.6 0.6 0.6
weirdColour = Colour 0.4 0.4 0.4
cloudy = Colour 0.69 0.69 0.69
glareColour = Colour 1 0.84 0
sky1 = Colour 0.84 0.84 0.84
sky2 = Colour 0.46 0.8 0.8
sky3 = Colour 0 0.6 0.88
grass1Colour = Colour 0.28 0.51 0.08
darkOrange = Colour 1 0.55 0
burgundy = Colour 0.8 0.1 0.1
violet = Colour 0.54 0.17 0.89

{----------}
{-Segments-}
{----------}

segmentG x y = Go x :#: Turn 90 :#: Go y :#: Turn 90 :#: Go x :#: Turn (-90) :#: Go y :#: Turn (-90)

segmentLoG = segmentG 1000 2
segmentHiG = segmentG 1000 1
segmentOG = segmentG 500 1
segment1P = segmentG 125 0.1
segment2P = segmentG 42 0.06
segment3P = segmentG 125 0.04
segment4P = segmentG 156 0.06
segment5P = segmentG 200 0.06
segment1C = segmentG 200 0.07
segment2C = segmentG 80 0.06
segment3C = segmentG 90 0.05
segment3'C = segmentG 90 0.06
segment1'C = segmentG 200 0.05
segmentR = segmentG 150 0.5
segmentR2 = segmentG 50 0.45
segmentR3 = segmentG 35 0.37

{------}
{-Rain-}
{------}


rain1 = Turn 30 :#: repeater segmentR 2 :#: Go 75
rain2 = Turn 45 :#: repeater segmentR 2 :#: Go 75
rain1' = Turn 30 :#: repeater segmentR2 2 :#: Go 50
rain2' = Turn 45 :#: repeater segmentR2 2 :#: Go 50
rain1'' = Turn 30 :#: repeater segmentR3 2 :#: Go 35
rain2'' = Turn 45 :#: repeater segmentR3 2 :#: Go 35
ray1 = Turn 30 :#: repeater segmentR 8
ray2 = Turn 45 :#: repeater segmentR 8

rain = GrabPen rainColour :#: rain1 :#: Turn (-30) :#: GrabPen Inkless :#: Go 50 :#: GrabPen rainColour :#: rain2

rain' = GrabPen rainColour :#: rain1' :#: Turn (-30) :#: GrabPen Inkless :#: Go 40 :#: GrabPen rainColour :#: rain2'

rain'' = GrabPen rainColour :#: rain1'' :#: Turn (-30) :#: GrabPen Inkless :#: Go 35 :#: GrabPen rainColour :#: rain2''

chunkARain = rain :#: Turn (-25) :#: GrabPen Inkless :#: Go 100 :#: rain' :#: Turn 90 :#: GrabPen Inkless :#: Go 100 :#: Turn 50 :#: rain' :#: GrabPen Inkless :#: Go 300 :#: Turn (-50) :#: rain' :#: Turn 150 :#: GrabPen Inkless :#: Go 500 :#: Turn 130 :#: rain :#: Turn (-25) :#: GrabPen Inkless :#: Go 100 :#: rain :#: Turn 90 :#: GrabPen Inkless :#: Go 100 :#: Turn 50 :#: rain' :#: GrabPen Inkless :#: Go 300 :#: Turn (-50) :#: rain'

biggerChunkARain = chunkARain :#: Turn 220 :#: GrabPen Inkless :#: Go 250 :#: Turn (-100) :#: chunkARain

evenBiggerChunkARain = biggerChunkARain :#: Turn 125 :#: GrabPen Inkless :#: Go 550 :#: Turn 175 :#: biggerChunkARain

theBiggestChunkARain = evenBiggerChunkARain :#: Turn (-90) :#: Turn (-10) :#: GrabPen Inkless :#: Go 500 :#:Turn (-90) :#: evenBiggerChunkARain

ray x = ray1 :#: Turn (-30) :#: GrabPen Inkless :#: Go x :#: GrabPen sunnyS :#: ray2

lightRain = rain'' :#: Turn 120 :#: GrabPen Inkless :#: Go 95 :#: Turn 180 :#: rain''

biggerLightRain = lightRain :#: Turn 130 :#: GrabPen Inkless :#: Go 150 :#: Turn 180 :#: lightRain

{-------}
{-Links-}
{-------}

linkGroundTree1 = GrabPen Inkless :#: Turn 105 :#: Go 300 :#: Turn 60
linkTree1Pyramid = GrabPen Inkless :#: Turn 5 :#: Go 180 :#: Turn 100
linkPyramidCube = GrabPen Inkless :#: Turn 100 :#: Go 500 :#: Turn 118.7

{------------}
{-Snowflakes-}
{------------}

reallySmallSnowflake = GrabPen black :#: snowflake 2 1.5
smallSnowflake = GrabPen black :#: snowflake 2 2.7
bigSnowflake = GrabPen black :#: snowflake 3 3
mediumSnowflake = GrabPen black :#: snowflake 3 2
smallCrossSnowflake = GrabPen treeWinter2 :#: cross 2 1.4
mediumCrossSnowflake = GrabPen treeWinter2 :#: cross 3 0.6
bigCrossSnowflake = GrabPen treeWinter2 :#: cross 3 1
smallSegmentSnowflake = GrabPen treeWinter2 :#: segment32 2 0.3 90
mediumSegmentSnowflake = GrabPen crossColour :#: segment32 2 0.5 90
bigSegmentSnowflake = GrabPen crossColour :#: segment32 2 1 90
bigWeirdSnowflake = GrabPen treeWinter2 :#: segment32 2 0.5 80
bigWeirdSnowflake2 = GrabPen weirdColour :#: segment32 2 0.53 70
mediumWeirdSnowflake3 = GrabPen weirdColour :#: segment32 2 0.4 60
bigWeirdSnowflake3 = GrabPen weirdColour :#: segment32 2 0.53 60
bigWeirdSnowflake4 = GrabPen weirdColour :#: segment32 2 0.53 50
bigWeirdSnowflake5 = GrabPen weirdColour :#: segment32 2 0.5 40

{-----}
{-Sky-}
{-----}

skyLine n c = GrabPen c :#: partCircle2 n :#: Turn 55 :#: GrabPen Inkless :#: Go (n*17.3) :#: Turn 60 :#: GrabPen c :#: partCircle2 n :#: Turn (-110) :#: GrabPen Inkless :#: Go (n*17.3) :#: Turn 70 :#: GrabPen c :#: partCircle2 n :#: Turn 55 :#: GrabPen Inkless :#: Branch (Go (n*17.3) :#: Turn 60 :#: GrabPen c :#: partCircle2 n) :#: Turn (-110) :#: GrabPen Inkless :#: Go (n*17.3) :#: Turn 70 :#: GrabPen c

skyLines = Turn (-80) :#: rayss :#: Turn (-70) :#: GrabPen Inkless :#: Go 400 :#: glare 7 :#: GrabPen black :#: Turn 80 :#: GrabPen Inkless :#: Go 600 :#: Turn 20 :#: skyLine 9 sky3 :#: Turn 90 :#: GrabPen Inkless :#: Turn (-20) :#: Go 450 :#: Turn 20 :#: skyLine 10 sky1 :#: Turn 90 :#: GrabPen Inkless :#: Turn (-40) :#: Go 800 :#: Turn 40 :#: skyLine 11 sky2   :#: Turn 90 :#: GrabPen Inkless :#: Turn (-20) :#: Go 500 :#: Turn 20 :#: skyLine 11 sky1

{------}
{-Suns-}
{------}

sunSpring = GrabPen sunnyS :#: repeater (ray 50) 8
sunWinter = GrabPen sunnyW :#: branch' 7
sunSummer = Turn 50 :#: Go 400 :#: GrabPen sunnyS :#: branch'' 7

{------}
{-Rays-}
{------}

rays = Turn 120 :#: GrabPen Inkless :#: Go 100 :#: Turn (-25) :#: GrabPen sunnyS :#: (Branch (Go 300)) :#: Turn 20 :#: (Branch (Go 400)) :#: Turn 20 :#: (Branch (Go 500)) :#: Turn 20 :#: (Branch (Go 200)) :#: Turn 20 :#: (Branch (Go 400)) :#: Turn 20 :#: (Branch (Go 300))

rayss = Turn 120 :#: GrabPen Inkless :#: Go 100 :#: Turn (-25) :#: GrabPen sunnyS :#: (Branch (segmentG 400 1)) :#: Turn 20 :#: (Branch (segmentG 500 1)) :#: Turn 20 :#: (Branch (segmentG 700 1)) :#: Turn 20 :#: (Branch (segmentG 300 1)) :#: Turn 20 :#: (Branch (segmentG 500 1)) :#: Turn 20 :#: (Branch (segmentG 400 1)) :#: Turn 20 :#: (Branch (segmentG 300 1))

{-------}
{-Glare-}
{-------}

glare n = GrabPen glareColour :#: circle n :#: GrabPen Inkless :#: Go (20*n) :#: GrabPen glareColour :#: circle (n*0.7) :#: GrabPen Inkless :#: Go (10*n) :#: GrabPen glareColour :#: circle (0.5*n) :#: GrabPen Inkless :#: Turn (-3) :#: Go (25*n) :#: GrabPen glareColour :#: circle (0.2*n)

{-------}
{-Birds-}
{-------}

bird1 = GrabPen black :#: Branch (partCircle 4 :#: Turn (-50) :#: partCircle 4) :#: Go 5 :#: (partCircle 4 :#: Turn (-50) :#: partCircle 4) :#: Go 5

bird2 = GrabPen black :#: Branch (partCircle 3 :#: Turn (-50) :#: partCircle 3) :#: Go 4 :#: (partCircle 3 :#: Turn (-50) :#: partCircle 3) :#: Go 4

bird3 = GrabPen black :#: Branch (partCircle 2.5 :#: Turn (-50) :#: partCircle 2.5) :#: Go 3.5 :#: (partCircle 2.5 :#: Turn (-50) :#: partCircle 2.5) :#: Go 3.5

bird4 = GrabPen black :#: Branch (partCircle 2 :#: Turn (-50) :#: partCircle 2) :#: Go 3 :#: (partCircle 2 :#: Turn (-50) :#: partCircle 2) :#: Go 3

bird5 = GrabPen black :#: Branch (partCircle 1.5 :#: Turn (-50) :#: partCircle 1.5) :#: Go 2.5 :#: (partCircle 1.5 :#: Turn (-50) :#: partCircle 1.5) :#: Go 2.5

bird6 = GrabPen black :#: Branch (partCircle 1 :#: Turn (-50) :#: partCircle 1) :#: Go 2 :#: (partCircle 1 :#: Turn (-50) :#: partCircle 1) :#: Go 2

halfABird = GrabPen black :#: Branch (partCircle 1 :#: Turn (-50) :#: GrabPen Inkless :#: partCircle 1) :#: Go 2 :#: (partCircle 1 :#: Turn (-50) :#: GrabPen Inkless :#: partCircle 1) :#: Go 2

{-------}
{-Trees-}
{-------}

tree1 = GrabPen treeAutumn :#:  branch 4
tree1' = GrabPen treeAutumn2 :#: fractal treeAutumn2 4
tree1'' = GrabPen treeAutumn2 :#:  branch 4
tree2 = GrabPen treeWinter :#: branch 4
tree2' = GrabPen treeWinter :#: fractal treeWinter2 4
tree2'' = GrabPen treeWinter2 :#: branch 4
tree3 = GrabPen treeSummer :#: branch 4
tree3' = GrabPen treeSummer2 :#: fractal treeSummer2 4
tree3'' = GrabPen treeSummer2 :#:  branch 4
tree4 = GrabPen treeSpring :#: branch 4
tree4' = GrabPen treeSpring2 :#: fractal treeSpring2 5
tree4'' = GrabPen treeSpring2 :#:  branch 4

{--------}
{-Ground-}
{--------}

loGround = GrabPen brown :#: Turn 90 :#: repeater segmentLoG 6

hiGround = Turn 90 :#: repeater segmentHiG 8 :#: Go 1000 :#: Turn 180

obl1Ground = Turn (-140) :#: repeater segmentOG 10 :#: Go 500 :#: Turn 50

obl2Ground = Turn (-140) :#: repeater segmentOG 8 :#: Go 500 :#: Turn 50

ground = loGround :#: Turn 90 :#: Go (-7) :#: Turn (-90) :#: obl1Ground :#: hiGround :#: Turn 90 :#: Go 13 :#: Turn (-90) :#: obl2Ground

{---------}
{-Pyramid-}
{---------}

pyramid1 = Turn 90 :#: repeater segment1P 20
pyramid2 = Turn 231.5 :#: repeater segment2P 20 :#: Go 42
pyramid3 = Turn 50 :#: repeater segment3P 20 :#: Go 125
pyramid4 = Turn 269.75 :#: repeater segment4P 20 :#: Go 156
pyramid5 = Turn 141.5 :#: repeater segment5P 20
pyramid = GrabPen black :#: pyramid1 :#: Branch (pyramid2 :#: pyramid3) :#: pyramid4 :#: pyramid5

{--------------------------}
{-Cube...Not really though-}
{--------------------------}

cube1 = Turn 90 :#: repeater segment1C 20
cube2 = Turn 210 :#: repeater segment2C 20 :#: Go 80
cube3 = Turn 60 :#: repeater segment3C 20 :#: Go 90
cube2' = Turn 120 :#: repeater segment2C 20 :#: Go 80
cube2'' = Turn 300 :#: repeater segment2C 20 :#: Go 80
cube3' = Turn 60 :#: repeater segment3'C 20 :#: Go 90
cube3'' = Turn (-90) :#: repeater segment3'C 20 :#: Go 90
cube1' = Turn (-90) :#: Go 1.5 :#: Turn (60) :#: repeater segment1'C 20
cube1'' = Turn 180 :#: cube1
cube = GrabPen black :#: Branch (cube1 :#: cube2 :#: cube3 :#: cube2' :#: cube3') :#: Turn 90 :#: Go 200 :#: cube3'' :#: Branch (cube2'' :#: cube1') :#: cube1''

{---------}
{-Drawing-}
{---------}

drawing :: Command -> Command
drawing x = ground :#: linkGroundTree1 :#: x :#: linkTree1Pyramid :#: pyramid :#: linkPyramidCube :#: cube

base x y z = drawing y :#: Turn 120 :#: GrabPen Inkless :#: Go 75 :#: Turn (-33) :#: x :#: Turn (-20) :#: GrabPen Inkless :#: Go 200 :#: Turn 110 :#: x :#: Turn (-35) :#: GrabPen Inkless :#: Go 267 :#: Turn 125 :#: z :#: Turn 93 :#: GrabPen Inkless :#: Go 800 :#: Turn (-90) :#: z :#: Turn (-98) :#: GrabPen Inkless :#: Go 475 :#: Turn 90 :#: y :#: Turn (-53) :#: GrabPen Inkless :#: Go 275 :#: Turn 140 :#: y :#: Turn 205 :#: GrabPen Inkless :#: Go 550 :#: Turn (-115) :#: y :#: Turn (-60) :#: GrabPen Inkless :#: Go 210 :#: Turn 150 :#: y :#: Turn 201 :#: GrabPen Inkless :#: Go 715 :#: Turn (-100) :#: x :#: Turn 75 :#: GrabPen Inkless :#: Go 600

weatherAutumn = Go (-100) :#: theBiggestChunkARain :#: Turn (-95) :#: GrabPen Inkless :#: Go 280 :#:Turn 75 :#: biggerLightRain :#: Turn 125 :#: GrabPen Inkless :#: Go 275 :#: Turn (-130) :#: biggerLightRain :#: Turn 205 :#: GrabPen Inkless :#: Go 1050 :#: Turn 50 :#: cloud 4 :#: Turn 90 :#: GrabPen Inkless :#: Go 100 :#: cloud 3 :#: Turn (-120) :#: partCircle 0.8

weatherWinter = bigSnowflake :#: Turn (-20) :#: GrabPen Inkless :#: Go 250 :#: mediumSnowflake :#: GrabPen Inkless :#: Go 200 :#: bigCrossSnowflake :#: Turn (-90) :#: GrabPen Inkless :#: Go 500 :#: bigSegmentSnowflake :#: Turn (-80) :#: GrabPen Inkless :#: Go 250 :#: smallSnowflake :#: Turn 100 :#: GrabPen Inkless :#: Go 250 :#: smallCrossSnowflake :#: Turn 130 :#: GrabPen Inkless :#: Go 550 :#: mediumCrossSnowflake :#: Turn 95 :#: GrabPen Inkless :#: Go 360 :#: mediumSegmentSnowflake :#: Turn 160 :#: GrabPen Inkless :#: Go 700 :#: smallSegmentSnowflake :#: Turn 130 :#: GrabPen Inkless :#: Go 300 :#: bigWeirdSnowflake :#: Turn 180 :#: GrabPen Inkless :#: Go 500 :#: bigWeirdSnowflake2 :#: Turn (-140) :#: GrabPen Inkless :#: Go 650 :#: bigWeirdSnowflake3 :#: Turn 135 :#: GrabPen Inkless :#: Go 200 :#: bigWeirdSnowflake4 :#: Turn 65 :#: GrabPen Inkless :#: Go 300 :#: bigWeirdSnowflake5 :#: Turn (-70) :#: GrabPen Inkless :#: Go 400 :#: smallSnowflake :#: Turn (-60) :#: GrabPen Inkless :#: Go 250 :#: smallSnowflake :#: GrabPen Inkless :#: Go 200 :#: smallSnowflake :#: GrabPen Inkless :#: Go 400 :#: smallSnowflake :#: Turn 210 :#: GrabPen Inkless :#: Go 700 :#: smallCrossSnowflake :#: Turn (-15) :#: GrabPen Inkless :#: Go 200 :#: smallSnowflake :#: Turn 170 :#: GrabPen Inkless :#: Go 330 :#: reallySmallSnowflake :#: Turn 90 :#: GrabPen Inkless :#: Go 600 :#: reallySmallSnowflake :#: Turn 90 :#: GrabPen Inkless :#: Go 200 :#: smallSnowflake :#: Turn 35 :#: GrabPen Inkless :#: Go 150 :#: reallySmallSnowflake :#: Turn (-40) :#: GrabPen Inkless :#: Go 100 :#: reallySmallSnowflake :#: Turn 75 :#: GrabPen Inkless :#: Go 230 :#: smallSnowflake :#: Turn 139 :#: GrabPen Inkless :#: Go 700 :#: mediumWeirdSnowflake3 :#: Turn 160 :#: GrabPen Inkless :#: Go 200 :#: smallSnowflake :#: Turn (-60) :#: GrabPen Inkless :#: Go 800

weatherSpring = GrabPen Inkless :#: Turn (-80) :#: Go 600 :#: Turn 160 :#: bird2 :#: Turn (-40) :#: GrabPen Inkless :#: Go 300 :#: Turn 205 :#: bird1 :#: Turn 170 :#: GrabPen Inkless :#: Go 150 :#: Turn 15 :#: bird2 :#: Turn (-10) :#: GrabPen Inkless :#: Go 670 :#: Turn 180 :#: Turn (-10) :#: bird2 :#: Turn 160 :#: GrabPen Inkless :#: Go 400 :#: bird3 :#: Turn 10 :#: GrabPen Inkless :#: Go 400 :#: Turn 180 :#: bird3 :#: Turn (-20) :#: GrabPen Inkless :#: Go 400 :#: Turn 180 :#: bird3 :#: Turn 90 :#: GrabPen Inkless :#: Go 200 :#: Turn 90 :#: bird4 :#: Turn 180 :#: GrabPen Inkless :#: Go 280 :#: Turn (-20) :#: bird4 :#: Turn 30 :#: GrabPen Inkless :#: Go 200 :#: Turn 140 :#: bird4 :#: GrabPen Inkless :#: Go 280 :#: Turn 180 :#: bird5 :#: Turn 90 :#: GrabPen Inkless :#: Go 150 :#: Turn 70 :#: bird6 :#: Turn 10 :#: GrabPen Inkless :#: Go (-300) :#: cloud 3 :#: Turn (-120) :#: partCircle 0.8 :#: Turn (-90) :#: Turn (-20) :#: GrabPen Inkless :#: Go 330 :#: Turn 200 :#: halfABird :#: Turn 160 :#: Go 800

grass c1 c2 = Turn (-57) :#: GrabPen Inkless :#: Go 1030 :#: Turn (-90) :#: patch c1 c2 0.8 :#: Turn 95 :#: Turn 19 :#: GrabPen Inkless :#: Go 150 :#: Turn 45 :#: patch c1 c2 0.6 :#: Turn 50 :#: GrabPen Inkless :#: Go 200 :#: patch c1 c2 0.6 :#: GrabPen Inkless :#: Turn (-45) :#: Go 150 :#: patch c1 c2 0.5 :#: Turn 50 :#: GrabPen Inkless :#: Go 320 :#: patch c1 c2 0.3 :#: Turn (-68) :#: GrabPen Inkless :#: Go 310 :#: patch c1 c2 0.3 :#: Turn (-73) :#: GrabPen Inkless :#: Go 440 :#: patch c1 c2 0.3 :#: GrabPen Inkless :#: Go 206 :#: Turn 105 :#: patch c1 c2 0.3 :#: Turn 140 :#: GrabPen Inkless :#: Go 250 :#: patch c1 c2 0.2

{---------------}
{-Final Command-}
{---------------}

autumn = display (base tree1 tree1'' tree1' :#: weatherAutumn :#: GrabPen Inkless :#: Turn (-30) :#: Go (-355) :#: Turn 270 :#: grass darkOrange burgundy)
winter = display (base tree2 tree2'' tree2' :#: weatherWinter :#: sunWinter :#: Turn 80 :#: GrabPen Inkless :#: Go 450 :#: Turn 30 :#: Go 150 :#: Turn (-29) :#: grass treeWinter treeWinter3)
spring = display (base tree3 tree3'' tree3' :#: weatherSpring :#: sunSpring :#: rays :#: GrabPen Inkless :#: Go 200 :#: Turn (-5) :#: Go 230 :#: Turn (-90) :#: Go 110 :#: Turn 60 :#: grass treeSummer violet)
summer = display (base tree4 tree4'' tree4' :#: sunSummer :#: skyLines :#: grass darkOrange treeSummer)

{----------}
{-Test Box-}
{----------}

flower c = partCircle2 10 :#: Turn 270 :#: GrabPen yellow :#: circle 1 :#: Turn 275 :#: GrabPen c :#: petala 1 :#: Turn 187 :#: petala 1 :#: Turn 190 :#: petala 1 :#: Turn 190 :#: petala 1

weirdThingy = circle 1 :#: Go 1 :#: circle 0.99 :#: Go 0.9 :#: circle 0.98 :#: Go 0.8 :#: circle 0.97 :#: Go 0.7 :#: circle 0.96 :#: Go 0.6 :#: circle 0.95 :#: Go 0.5 :#: circle 0.94 :#: Go 0.4 :#: circle 0.93 :#: Go 0.3 :#: circle 0.92